unit unMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan, ExtCtrls, ComCtrls, winuser, DrvMgr, NativeAPI,
  Menus;

type
  TfrmMain = class(TForm)
    XPManifest: TXPManifest;
    lst: TListView;
    Panel1: TPanel;
    cmd: TButton;
    mnu: TPopupMenu;
    Unhook1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure cmdClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Unhook1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  PMEMORY_REQUEST = ^MEMORY_REQUEST;
    MEMORY_REQUEST = packed record
      pDst: pointer;
	    pSrc: pointer;
	    dwBytesCount: DWORD;
      end;

  PCLIENT_ID = ^TCLIENT_ID;
    TCLIENT_ID = packed record
      UniqueProcess:cardinal;
      UniqueThread:cardinal;
      end;

const
  drName = 'hookmon';
  IOCTL_READ_KERNEL_MEMORY    = $00224004;
  IOCTL_GET_MODULE_ATOM       = $00224008;
  IOCTL_GET_CID_BY_PTI        = $0022400C;

var
  frmMain: TfrmMain;

  tHook: HOOK; //     DWORD
  drPath: string;
  hDriver, dwBytesReturned: cardinal;
  bDrLoaded: boolean;

implementation

{$R *.dfm}

const
  STATUS_SUCCESS              = 0;
  STATUS_INFO_LENGTH_MISMATCH = $C0000004;

  WH_KEYBOARD_LL              = 13;
  WH_MOUSE_LL                 = 14;

{
  AtomBasicInformation        = 0;
  AtomTableInformation        = 1;

type
  PATOM_BASIC_INFORMATION = ^ATOM_BASIC_INFORMATION;
    ATOM_BASIC_INFORMATION = packed record
      ReferenceCount: integer;
      Pinned: integer;
      NameLength: integer;
      Name: array [0..0] of WideChar;
      end;

function
  NtQueryInformationAtom(Atom: integer;
                         AtomInformationClass: DWORD;
                         AtomInformation: pointer;
                         AtomInformationLength: DWORD;
                         ReturnLength: pointer): DWORD; //NTSTATUS
                         stdcall; external 'ntdll.dll';

function GetAtomInfo(Atom: dword): pointer;
var
  mSize: dword;
  mPtr: pointer;
  St: DWORD;
begin
result := nil;
mSize := $4000;
repeat
  mPtr := VirtualAlloc(nil, mSize, MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE);
  if mPtr = nil then exit;
  St := NtQueryInformationAtom(Atom, AtomBasicInformation, mPtr, mSize, nil);
  if St = DWORD(STATUS_INFO_LENGTH_MISMATCH) then
    begin
    VirtualFree(mPtr, 0, MEM_RELEASE);
    mSize := mSize * 2;
    end;
until St <> DWORD(STATUS_INFO_LENGTH_MISMATCH);
if St = STATUS_SUCCESS then
  result := mPtr
else
  VirtualFree(mPtr, 0, MEM_RELEASE);
end;
}

function strlenA(const s: PAnsiChar): cardinal; register;
asm
  mov edx, edi
  mov edi, eax
  or ecx, -1
  xor eax, eax
  repne scasb
  dec eax
  dec eax
  sub eax, ecx
  mov edi, edx
end;

function upcaseA(c: AnsiChar): AnsiChar; register;
asm
  cmp al, 'a'
  jl @@1
  cmp al, 'z'
  jg @@1
  and al, $df
@@1:
end;

function hexAtoui(const hex: PAnsiChar): Cardinal; stdcall;
var
  j, len: integer;
  k: cardinal;
  c: byte;
begin
  result := 0;
  len := strlenA(hex) - 1;
  k := 16;
  for j := 0 to len do
  begin
    c := BYTE(upcasea(hex[j]));
    if (c >= $30) and (c <= $39) then k := c - $30;
    if (c >= $41) and (c <= $46) then k := (c - $37);
    if (k > 15) then
    begin
      result := 0;
      exit;
    end;
    result := result + k shl ((len - j) * 4);
  end;
end;

function OpenDriver (access: cardinal): boolean;
begin
result := false;
hDriver := CreateFile(PChar('\\.\' + drName), access, 0, nil, OPEN_EXISTING, 0, 0);
if hDriver = INVALID_HANDLE_VALUE then
  exit;
result := true;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
if gSharedInfo = nil then
  begin
  MessageBox(Self.Handle, 'Unsupported OS', 'Error', MB_ICONERROR);
  Application.Terminate;
  exit;
  end;

EnablePrivilegeEx(INVALID_HANDLE_VALUE, 'SeDebugPrivilege');

drPath := ExtractFilePath(paramstr(0)) + 'hookmon.sys';
if not InstallDriver(drName, PChar(drPath)) then
  begin
  MessageBox(Self.Handle, '  ', '', MB_ICONERROR);
  Application.Terminate;
  exit;
  end;
LoadDriver(drName);

if not OpenDriver(GENERIC_READ or GENERIC_WRITE) then
  begin
  UnloadDriver(drName);
  UninstallDriver(drName);
  MessageBox(Self.Handle, '  ', '', MB_ICONERROR);
  Application.Terminate;
  exit;
  end;

bDrLoaded := true;
end;

function  GetWHString(wh: DWORD): string;
begin
case wh of
  WH_CALLWNDPROC:
    result := 'WH_CALLWNDPROC';
  WH_CALLWNDPROCRET:
    result := 'WH_CALLWNDPROCRET';
  WH_CBT:
    result := 'WH_CBT';
  WH_DEBUG:
    result := 'WH_DEBUG';
  WH_FOREGROUNDIDLE:
    result := 'WH_FOREGROUNDIDLE';
  WH_GETMESSAGE:
    result := 'WH_GETMESSAGE';
  WH_JOURNALPLAYBACK:
    result := 'WH_JOURNALPLAYBACK';
  WH_JOURNALRECORD:
    result := 'WH_JOURNALRECORD';
  WH_KEYBOARD:
    result := 'WH_KEYBOARD';
  WH_KEYBOARD_LL:
    result := 'WH_KEYBOARD_LL';
  WH_MOUSE:
    result := 'WH_MOUSE';
  WH_MOUSE_LL:
    result := 'WH_MOUSE_LL';
  WH_MSGFILTER:
    result := 'WH_MSGFILTER';
  WH_SHELL:
    result := 'WH_SHELL';
  WH_SYSMSGFILTER:
    result := 'WH_SYSMSGFILTER';
  end;
end;

function  ReadKernelMemory(pDst, pSrc: pointer; dwBytesCount: DWORD): boolean;
var
  mr: MEMORY_REQUEST;
begin
ZeroMemory(@mr, SizeOf(MEMORY_REQUEST));
mr.pDst := pDst;
mr.pSrc := pSrc;
mr.dwBytesCount := dwBytesCount;
result := DeviceIoControl(hDriver,
                          IOCTL_READ_KERNEL_MEMORY,
                          @mr, SizeOf(MEMORY_REQUEST),
                          nil,
                          0,
                          dwBytesReturned,
                          nil);
end;

function  GetModuleAtom(ihmod: integer): DWORD;
begin
result := 0;
DeviceIoControl(hDriver,
                IOCTL_GET_MODULE_ATOM,
                @ihmod, SizeOf(DWORD),
                @result, SizeOf(DWORD),
                dwBytesReturned,
                nil);
end;

procedure GetProcessIdByPti(pti: pointer; pcid: PCLIENT_ID);
begin
DeviceIoControl(hDriver,
                IOCTL_GET_CID_BY_PTI,
                @pti, SizeOf(TCLIENT_ID), // !!!
                pcid, SizeOf(TCLIENT_ID),
                dwBytesReturned,
                nil);
end;

function GetNameByPid(Pid: dword): string;
var
  hProcess, Bytes: cardinal;
  Info: PROCESS_BASIC_INFORMATION;
  ProcessParametres: pointer;
  ImagePath: TUnicodeString;
  ImgPath: array[0..MAX_PATH] of WideChar;
begin
result := '';
ZeroMemory(@ImgPath, MAX_PATH * SizeOf(WideChar));
hProcess := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, false, Pid);
if ZwQueryInformationProcess(hProcess, ProcessBasicInformation, @Info,
                              SizeOf(PROCESS_BASIC_INFORMATION), nil) = STATUS_SUCCESS then
  begin
    if ReadProcessMemory(hProcess, pointer(dword(Info.PebBaseAddress) + $10),
                        @ProcessParametres, SizeOf(pointer), Bytes) and
      ReadProcessMemory(hProcess, pointer(dword(ProcessParametres) + $38),
                        @ImagePath, SizeOf(TUnicodeString), Bytes)  and
      ReadProcessMemory(hProcess, ImagePath.Buffer, @ImgPath,
                        ImagePath.Length, Bytes) then
        begin
        result := WideCharToString(ImgPath);
        end;
   end;
CloseHandle(hProcess);
end;

procedure TfrmMain.cmdClick(Sender: TObject);
var
  i, cHooks: integer;
  phe: PHANDLEENTRY;
  li: TListItem;
  Atom: DWORD;
  dllPath: array [0..255] of WideChar;
  cid: TCLIENT_ID;
begin
lst.Items.Clear;
cHooks := 0;
for i := 0 to HMINDEXBITS - 1 do
  begin
  phe := @gSharedInfo.aheList[i];
  try
    if phe.bType = TYPE_HOOK then
      begin
      Inc(cHooks);
      frmMain.Caption := 'Hooks found: ' + IntToStr(cHooks);
      ZeroMemory(@tHook, SizeOf(HOOK));
      if ReadKernelMemory(@tHook, phe.pHead, SizeOf(HOOK)) then
        begin
        ZeroMemory(@cid, SizeOf(TCLIENT_ID));
        // tHook.ptiHooked == NULL   ,
        //    tHook.ptiHooked == tHook.head.throbjhead.pti
        GetProcessIdByPti(tHook.head.throbjhead.pti, @cid);
        li := lst.Items.Add;
        li.Caption := IntToHex(tHook.head.throbjhead.head.h, 8);
        li.SubItems.Add(GetWHString(tHook.iHook));
        li.SubItems.Add(IntToHex(tHook.offPfn, 8));
        li.SubItems.Add(IntToStr(cid.UniqueProcess));
        li.SubItems.Add(IntToStr(cid.UniqueThread));
        if tHook.ihmod <> -1 then
          begin
          Atom := GetModuleAtom(tHook.ihmod);
          if Atom <> 0 then
            begin
            ZeroMemory(@dllPath, 512);
            GetClipboardFormatNameW(Atom, @dllPath, 256);
            li.SubItems.Add(Trim(WideString(dllPath)));
            end
          end
        else
          li.SubItems.Add(GetNameByPid(cid.UniqueProcess));
        end;
      end;
    except
      break;
    end;
  end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if bDrLoaded then
  begin
  bDrLoaded := false;
  UnloadDriver(drName);
  UninstallDriver(drName);
  end;
end;

procedure TfrmMain.Unhook1Click(Sender: TObject);
begin
if lst.SelCount > 0 then
  begin
  UnhookWindowsHookEx(hexAtoui(PChar(lst.Selected.Caption)));
  cmdClick(self);
  end;
end;

end.
